#include <stdio.h>
#include <stdlib.h>
//#include <curses.h>
#include <unistd.h>
#include <sys/types.h>
#include <dirent.h>
#include <string>
#include <fstream>
#include <vector>

#define STRING std::string
#define IFSTREAM std::ifstream

struct process
{
	process( const char * myname, int parent, int mypid){ name = myname; ppid = parent; pid = mypid;}
	std::string name;
	int pid,ppid;
};

#define VECTOR std::vector<process *>

int str2int( const char * what)
{
	int retval = 0;

	for( int i = 0; what[i]; i++)
	{
		if( what[i] < '0' || what[i] > '9')
//		{
//			printf("Return because: %c\n", what[i]);
			return -1;
//		}

//		printf("%d ", retval);
		retval *= 10;
		retval += what[i] - '0';
	}
//	printf("\n");

	return retval;
}

struct process * getprocess(const char * processnum, int pid)
{
	char name[256];
	unsigned int ppid;

	STRING temp = "/proc/";
	temp += processnum;
	temp += "/status";

	IFSTREAM mystat( temp.c_str());
	STRING line;

	if( !mystat.good())
		return NULL;

	if( !getline(mystat,line))
		return NULL;

	sscanf( line.c_str(), "Name:\t%s", name);

	if( !getline(mystat,line))
		return NULL;

	if( !getline(mystat,line))
		return NULL;

	if( !getline(mystat,line))
		return NULL;

	if( !getline(mystat,line))
		return NULL;

	sscanf( line.c_str(), "PPid:\t%d", &ppid);

//printf("BEFORE FREE\n");
//printf("after free\n");

//	printf("%s, %d\n", name, ppid);
  mystat.close();

	return new struct process( name, ppid, pid);
}

int traverse( const VECTOR & myvect, int ppid, int index)
{
	for( unsigned int i = index; i < myvect.size(); i++)
		if( myvect[i] != NULL && myvect[i]->ppid == ppid)
			return i;

	return -1;
}

void printtree( VECTOR & myvect, int tab, int place)
{
	int pid = myvect[place]->pid;

	printf("%d\t", pid);
	
	for( int i = 0; i < tab; i++)
		printf("  ");

//printf("%d");
	printf("\\_%s\n", myvect[place]->name.c_str());
//printf("HERE:\n");

	delete myvect[place];
	myvect[place] = NULL;
	
	int next = 0;
	
	while( next != -1)
	{
		if( (next = traverse( myvect, pid, next)) != -1)
			printtree( myvect, tab + 1, next);
	}	
}

int Pstree()
{
	VECTOR myvect;
	int myproc;
	DIR * mydir = opendir( "/proc");
	struct process * myprocess = NULL;
	dirent * myent;
	printf("pid\tname\n\n");

	if( mydir == NULL)
		return 0;
	
	do{
		if ( (myent = readdir( mydir)) == 0)
			break;

//		printf("ORIG: %s\n", myent->d_name);
		
		if( ( myproc = str2int( myent->d_name)) != -1)
//		{
//			printf("%d", myproc);
			myprocess = getprocess( myent->d_name, myproc);
//		}

		if( myprocess != NULL)
			myvect.push_back( myprocess);
//		{
//			printf("%d\t%d\t%s\n", myprocess->ppid, myprocess->pid, myprocess->name.c_str());
//			delete myprocess;
//			myprocess = NULL;
//		}

	}while( myent != NULL);

	unsigned int initplace = 0;
	
	for(; initplace < myvect.size(); initplace++)
		if( myvect[initplace]->pid == 1)
			break;

//	for(int i = 0; i < myvect.size(); i++)
//		printf("%d ",  myvect[i]->pid);

//	printf("\n");

//printf("HERE: %d\n", initplace);
	printtree( myvect, 0, initplace);

	return closedir( mydir);
}
